\subsection*{Projection of an equi-distance manifold}

Given two points $\bar{\bf l}$ and $\bar{\bf r}$ in ${\cal R}^d$ we look for their projection ${\bf l}$ and ${\bf r}$ on the manifold of dimension $d-1$ defined by $\|{\bf l} - \bar{\bf r}\| \;\diamond\; d$, with $\diamond \in \{=, \le, \ge\}$, i.e.,, of a predefined inter-distance and such that $d({\bf l}, \bar{\bf l})$ and $d({\bf r}, \bar{\bf r})$ is minimal.

This may be written in variational form:
\eqline{\min_{{\bf l},{\bf r}} {\cal L}, \;\;\; {\cal L} \deq \frac{1}{2} \, \left(\|{\bf l} - \bar{\bf l}\|^2 + \|{\bf r} - \bar{\bf r}\|^2\right) + \frac{\lambda}{2} \, \left( \|{\bf l} - \bar{\bf r}\|^2 \;\diamond\; d^2 \right),}
which normal equations yield:
\eqline{\begin{array}{rclcl}
 0 &=& \partial_{\bf l}{\cal L} &=& ({\bf l} - \bar{\bf l}) + \lambda \, ({\bf l} - \bar{\bf r}) \\
 0 &=& \partial_{\bf r}{\cal L} &=& ({\bf r} - \bar{\bf r}) + \lambda \, ({\bf r} - \bar{\bf l}) \\
 0 &=& \partial_{\lambda}{\cal L} &=& \|{\bf l} - \bar{\bf r}\|^2 \diamond d^2 \\
\end{array}}
and it is easy to verify that the solution writes:
\eqline{\begin{array}{rcl}
 {\bf l} &=& \frac{\bar{\bf l} + \bar{\bf r}}{2} +
    \frac{d}{2\,\|\bar{\bf l} - \bar{\bf r}\|} \, (\bar{\bf l} - \bar{\bf r}) \\
 {\bf r} &=& \frac{\bar{\bf l} + \bar{\bf r}}{2} +
    \frac{d}{2\,\|\bar{\bf l} - \bar{\bf r}\|} \, (\bar{\bf r} - \bar{\bf l} )\\
\end{array}}
the 1st term allowing to be as close as possible to the original values and the second term to fruitful the distance requirement, as verified from a small piece of computer algebra code\footnote{\url{https://gitlab.inria.fr/line/aide-group/symbolingfield/-/raw/master/src/distancetype.mpl?ref_type=heads}}. In the scalar case, it simplifies to:
\eqline{\begin{array}{rcl}
 l &=& \frac{\bar{l} + \bar{r}}{2} + \mbox{sign}(\bar{l} - \bar{r}) \, \frac{d}{2} \\
 r &=& \frac{\bar{l} + \bar{r}}{2} + \mbox{sign}(\bar{r} - \bar{l}) \, \frac{d}{2} \\
\end{array}}

\newpage

At a geometric level, in the ${\cal R}^{2\,d} = {\cal R}^d \times {\cal R}^d$ space, the hyper-surface $\|{\bf l} - \bar{\bf r}\|^2 = d^2$ is the hypersphere\footnote{Since $\|{\bf l} - \bar{\bf r}\|^2 = d^2$ writes in matrix form:
\eqline{
  {\bf l}^T \, {\bf l} - 2 \, {\bf l}^T \, {\bf r} + {\bf r}^T \, {\bf r} = 
  \left( \begin{array}{cc} {\bf l}^T & {\bf r}^T \end{array} \right) \,
  \underbrace{\left( \begin{array}{cc} {\bf I} & -{\bf I} \\ -{\bf I} & {\bf I} \\\end{array} \right)}_{\deq {\bf Q}} \,
  \left( \begin{array}{c} {\bf l} \\ {\bf r} \end{array} \right) = d^2}
with:
\eqline{{\bf Q} = {\bf R}^T \, {\bf L} \, {\bf R},
   {\bf R} \deq \frac{1}{\sqrt{2}} \left( \begin{array}{cc} {\bf I} & -{\bf I} \\ {\bf I} & {\bf I} \\\end{array} \right),
     {\bf L} \deq \left( \begin{array}{cc} 2 \, {\bf I} & {\bf 0} \\ {\bf 0} & {\bf 0} \\\end{array} \right)}
using ${\bf R}$, with ${\bf R}^T \, {\bf R}$, thus a rotation, as change of coordinates, we are left a quadratic form defined by ${\bf L}$, thus an hypersphere in a linear subspace, as expected.} of radius $d/\sqrt{2}$ in the linear subspace defined by ${\bf l} + {\bf r} = 0$, while it vanishes in the orthogonal linear subspace defined by ${\bf l} = {\bf r}$.

This very simple geometry is interesting because it allows one to see that ``outside'', i.e., for $\|{\bf l} - \bar{\bf r}\| \;>\; d$ the hyper-surface is convex.


